##=============================================================================
##
##	mpc555.inc
##
##=============================================================================

#------------------------------------------------------------------------------
# Easier to read names for the registers

	.equ	r0, 0
	.equ	r1, 1
	.equ	r2, 2
	.equ	r3, 3
	.equ	r4, 4
	.equ	r5, 5
	.equ	r6, 6
	.equ	r7, 7
	.equ	r8, 8
	.equ	r9, 9
	.equ	r10, 10
	.equ	r11, 11
	.equ	r12, 12
	.equ	r13, 13
	.equ	r14, 14
	.equ	r15, 15
	.equ	r16, 16
	.equ	r17, 17
	.equ	r18, 18
	.equ	r19, 19
	.equ	r20, 20
	.equ	r21, 21
	.equ	r22, 22
	.equ	r23, 23
	.equ	r24, 24
	.equ	r25, 25
	.equ	r26, 26
	.equ	r27, 27
	.equ	r28, 28
	.equ	r29, 29
	.equ	r30, 30
	.equ	r31, 31

	.equ	f0, 0
	.equ	f1, 1
	.equ	f2, 2
	.equ	f3, 3
	.equ	f4, 4
	.equ	f5, 5
	.equ	f6, 6
	.equ	f7, 7
	.equ	f8, 8
	.equ	f9, 9
	.equ	f10, 10
	.equ	f11, 11
	.equ	f12, 12
	.equ	f13, 13
	.equ	f14, 14
	.equ	f15, 15
	.equ	f16, 16
	.equ	f17, 17
	.equ	f18, 18
	.equ	f19, 19
	.equ	f20, 20
	.equ	f21, 21
	.equ	f22, 22
	.equ	f23, 23
	.equ	f24, 24
	.equ	f25, 25
	.equ	f26, 26
	.equ	f27, 27
	.equ	f28, 28
	.equ	f29, 29
	.equ	f30, 30
	.equ	f31, 31

	.equ    sprg0, 272
	.equ    sprg1, 273
	.equ    sprg2, 274
	.equ    sprg3, 275

	.equ	sp, r1

#------------------------------------------------------------------------------
# The debug registers
	.equ	der, 149
	.equ	ecr, 148

#------------------------------------------------------------------------------
# The MSR manipulation registers
	.equ	eie, 80
	.equ	eid, 81
	.equ	nri, 82

#------------------------------------------------------------------------------
# Some useful coding macros

	# Load immediate word, has to be done with 2 instructions
	.macro	lwi	reg,val
	lis	\reg,\val@H
	ori	\reg,\reg,\val@L
	.endm

	# enabling / disabling interrupts
	.macro STI
	mtspr eie, r0
	.endm

	.macro CLI
	mtspr eid, r0
	.endm

#------------------------------------------------------------------------------
# Exception, interrupt and thread context save area layout
# The layout of this structure is also defined in "hal_arch.h", for C
# code. Do not change this without changing that (or vice versa).

#ifdef CYGDBG_HAL_COMMON_INTERRUPTS_SAVE_MINIMUM_CONTEXT
	.equ	ex_ppcreg_reg,		0			# 14 integer registers
	.equ	ex_ppcreg_r14,		14*4			# r14
	.equ	ex_ppcreg_r15,		15*4			# r15
	.equ	ex_ppcreg_freg,		16*4			# 14 floating point registers
	.equ	ex_ppcreg_cr,		(16 + (2*14))*4
	.equ	ex_ppcreg_xer,		(17 + (2*14))*4
	.equ	ex_ppcreg_lr,		(18 + (2*14))*4
	.equ	ex_ppcreg_ctr,		(19 + (2*14))*4
	.equ	ex_ppcreg_msr,		(20 + (2*14))*4		# MSR at time of exception
	.equ	ex_ppcreg_pc,		(21 + (2*14))*4		# PC at time of exception

	.equ	ppcreg_ex_size,		(22 + (2*14))*4
#else
	.equ	ex_ppcreg_reg,		0			# 32 integer registers
	.equ	ex_ppcreg_freg,		32*4			# 32 floating point registers
	.equ	ex_ppcreg_cr,		(32 + (2*32))*4
	.equ	ex_ppcreg_xer,		(33 + (2*32))*4
	.equ	ex_ppcreg_lr,		(34 + (2*32))*4
	.equ	ex_ppcreg_ctr,		(35 + (2*32))*4
	.equ	ex_ppcreg_msr,		(36 + (2*32))*4		# MSR at time of exception
	.equ	ex_ppcreg_pc,		(37 + (2*32))*4		# PC at time of exception

	.equ	ppcreg_ex_size,		(38 + (2*32))*4
#endif

	# The following are only saved on exceptions and interrupts
	.equ	ex_ppcreg_vector,	ppcreg_ex_size + (0*4)	# exception vector

	# The following are only saved on exceptions, and are for information
	# only. They are not restored with the rest of the state.
	.equ	ex_ppcreg_hid0,		ppcreg_ex_size + (1*4)	# HID0 HW control register
	.equ	ex_ppcreg_dar,		ppcreg_ex_size + (2*4)	# data address register
	.equ	ex_ppcreg_dsisr,	ppcreg_ex_size + (3*4)	# DSI status register
	.equ	ex_ppcreg_pvr,		ppcreg_ex_size + (4*4)	# processor version
	.equ	ppcreg_exception_size, 	ppcreg_ex_size + (5*4)

        # Eventually add BATs, SRs and FP registers too.

	.equ	ppc_stack_frame_size,	56	# size of a stack frame

	.equ	ppc_exception_decrement, ppcreg_exception_size

#ifdef CYGDBG_HAL_COMMON_CONTEXT_SAVE_MINIMUM
	.equ	cont_ppcreg_reg,	0			# 18 integer registers
	.equ	cont_ppcreg_freg,	18*4			# 18 floating point registers

	.equ	cont_ppcreg_r0,		(18 + (18*2))*4
	.equ	cont_ppcreg_r1,		(19 + (18*2))*4
	.equ	cont_ppcreg_r2,		(20 + (18*2))*4
	.equ	cont_ppcreg_r3,		(21 + (18*2))*4

	.equ	cont_ppcreg_cr,		(22 + (18*2))*4
	.equ	cont_ppcreg_pc,		(23 + (18*2))*4
	.equ	cont_ppcreg_msr,	(24 + (18*2))*4
	.equ	cont_ppcreg_lr,		(25 + (18*2))*4

	.equ	ppcreg_context_size,	(26 + (18*2))*4
#else
	.equ	cont_ppcreg_reg,	0			# 26 integer registers
	.equ	cont_ppcreg_freg,	26*4			# 32 floating point registers

	.equ	cont_ppcreg_r0,		(26 + (32*2))*4
	.equ	cont_ppcreg_r1,		(27 + (32*2))*4
	.equ	cont_ppcreg_r2,		(28 + (32*2))*4
	.equ	cont_ppcreg_r3,		(29 + (32*2))*4

	.equ	cont_ppcreg_cr,		(30 + (32*2))*4
	.equ	cont_ppcreg_pc,		(31 + (32*2))*4
	.equ	cont_ppcreg_msr,	(32 + (32*2))*4
	.equ	cont_ppcreg_lr,		(33 + (32*2))*4

	.equ	cont_ppcreg_xer,	(34 + (32*2))*4
	.equ	cont_ppcreg_ctr,	(35 + (32*2))*4

	.equ	ppcreg_context_size,	(36 + (32*2))*4
#endif


#------------------------------------------------------------------------------
# end of mpc555.inc
