		
		# All following definitions are given relative
		# to the IMMR base address 0x002fc00
		# It is important that section .immr be linked at 
		# address 0x002fc00, and that it be defined
		# a NON LOADABLE section.
		
		.section ".immr"

		#-------------------------------------------
		# Make all IMMR defined registers visible to
		# the linker
		#-------------------------------------------

		# General register definitions
		.global SIUMCR
		.global SYPCR
		.global SWSR
		.global SIPEND
		.global SIMASK
		.global SIEL
		.global SIVEC
		.global TESR
		.global SGPIODT1
		.global SGPIODT2
		.global SGPIOCR
		.global EMCR
		.global PDMCR

		# Memory controller registers
		.global BR0
		.global OR0
		.global BR1
		.global OR1
		.global BR2
		.global OR2
		.global BR3
		.global OR3
		.global DMBR
		.global DMOR
		.global MSTAT

		# System integration timers
		.global TBSCR
		.global TBREF0
		.global TBREF1
		.global RTCSC
		.global RTC
		.global RTSEC
		.global RTCAL
		.global PISCR
		.global PITC
		.global PITR

		# Clocks and resets
		.global SCCR
		.global PLPRCR
		.global RSR
		.global COLIR
		.global VSRMCR

		# System IntegrationTimer Keys
		.global TBSCRK
		.global TBREF0K
		.global TBREF1K
		.global TBK
		.global RTCSCK
		.global RTCK
		.global RTSECK
		.global RTCALK
		.global PISCRK
		.global PITCK

		# Clocks and reset keys
		.global SCCRK
		.global PLPRCRK
		.global RSRK

		#-------------------------------------
		# CMF (CDR Mone T FLASH EEPROM)
		#-------------------------------------
		# CMF_A
		.global CMFMCR_A
		.global CMFTST_A
		.global CMFCTL_A
	
		# CMF_B
		.global CMFMCR_B
		.global CMFTST_B
		.global CMFCTL_B

		#-------------------------------------
		# DPTRAM (Dual-Port TPU RAM)
		#-------------------------------------
		.global DPTMCR
		.global RAMTST
		.global RAMBAR
		.global MISRH
		.global MISRL
		.global MISCNT

		#-------------------------------------
		# TPU3 (Time processing unit)
		#-------------------------------------
		# TPU-A
		.global TPUMCR_A
		.global TCR_A
		.global DSCR_A
		.global DSSR_A
		.global TICR_A
		.global CIER_A
		.global CFSR0_A
		.global CFSR1_A
		.global CFSR2_A
		.global CFSR3_A
		.global HSQR0_A
		.global HSQR1_A
		.global HSRR0_A
		.global HSRR1_A
		.global CPR0_A
		.global CPR1_A
		.global CISR_A
		.global LR_A
		.global SGLR_A
		.global DCNR_A
		.global TPUMCR2_A
		.global TPUMCR3_A
		.global ISDR_A
		.global ISCR_A

       		# TPU-B
		.global TPUMCR_B
		.global TCR_B
		.global DSCR_B
		.global DSSR_B
		.global TICR_B
		.global CIER_B
		.global CFSR0_B
		.global CFSR1_B
		.global CFSR2_B
		.global CFSR3_B
		.global HSQR0_B
		.global HSQR1_B
		.global HSRR0_B
		.global HSRR1_B
		.global CPR0_B
		.global CPR1_B
		.global CISR_B
		.global LR_B
		.global SGLR_B
		.global DCNR_B
		.global TPUMCR2_B
		.global TPUMCR3_B
		.global ISDR_B
		.global ISCR_B


		#--------------------------------------------
		# QADC64 (Queued Analog-to-digital Converter)
		#--------------------------------------------
		# QUADC-A
		.global QUADC64MCR_A
		.global QUADC64TEST_A
		.global QUADC64INT_A
		.global PORTQA_A_PORTQB_A
		.global DDRQA_A_DDRQB_A
		.global QUACR0_A
		.global QUACR1_A
		.global QUACR2_A
		.global QUASR0_A
		.global QUASR1_A
		.global CCW_A
		.global RJURR_A
		.global LJSRR_A
		.global LJURR_A

		# QUADC-B
		.global QUADC64MCR_B
		.global QUADC64TEST_B
		.global QUADC64INT_B
		.global PORTQA_B_PORTQB_B
		.global DDRQA_B_DDRQB_B
		.global QUACR0_B
		.global QUACR1_B
		.global QUACR2_B
		.global QUASR0_B
		.global QUASR1_B
		.global CCW_B
		.global RJURR_B
		.global LJSRR_B
		.global LJURR_B

		#-------------------------------------------
		# QSMCM (Queued Serial Multi-Channel Module)
		#-------------------------------------------
		.global QSMCMMCR
		.global QTEST
		.global QDSCI_IL
		.global QSPI_IL
		.global SCC1R0
		.global SCC1R1
		.global SC1SR
		.global SC1DR
		.global PORTQS
		.global PQSPAR_DDRQST
		.global SPCR0
		.global SPCR1
		.global SPCR2
		.global SPCR3
		.global SPSR
		.global SCC2R0
		.global SCC2R1
		.global SC2SR
		.global SC2DR
		.global QSCI1CR
		.global QSCI1SR
		.global SCTQ
		.global SCRQ
		.global RECRAM
		.global TRAN_RAM
		.global COMD_RAM

		#---------------------------------------
		# MIOS1 (Modular Input/Output Subsystem)
		#---------------------------------------
		# MPIOS Pulse width modulation submodule 0
		.global MPWMSMPERR_0
		.global MPWMSMPULR_0
		.global MPWMSMCNTR_0
		.global MPWMSMSCR_0
		
		# MPIOS Pulse width modulation submodule 1
		.global MPWMSMPERR_1
		.global MPWMSMPULR_1
		.global MPWMSMCNTR_1
		.global MPWMSMSCR_1

		# MPIOS Pulse width modulation submodule 2
		.global MPWMSMPERR_2
		.global MPWMSMPULR_2
		.global MPWMSMCNTR_2
		.global MPWMSMSCR_2

		# MPIOS Pulse width modulation submodule 3
		.global MPWMSMPERR_3
		.global MPWMSMPULR_3
		.global MPWMSMCNTR_3
		.global MPWMSMSCR_3

		# MIOS Modulus counter submodule 6
		.global MMCSMCNT_6
		.global MMCSMML_6
		.global MMCSMSCRD_6
		.global MMCSMSCR_6

		# MIOS Double Action submodule 11
		.global MDASMAR_11
		.global MDASMBR_11
		.global MDASMSCRD_11
		.global MDASMSCR_11

		# MIOS Double Action submodule 12
		.global MDASMAR_12
		.global MDASMBR_12
		.global MDASMSCRD_12
		.global MDASMSCR_12

		# MIOS Double Action submodule 13
		.global MDASMAR_13
		.global MDASMBR_13
		.global MDASMSCRD_13
		.global MDASMSCR_13

		# MIOS Double Action submodule 14
		.global MDASMAR_14
		.global MDASMBR_14
		.global MDASMSCRD_14
		.global MDASMSCR_14

		# MIOS Double Action submodule 15
		.global MDASMAR_15
		.global MDASMBR_15
		.global MDASMSCRD_15
		.global MDASMSCR_15

		# MPIOS Pulse width modulation submodule 16
		.global MPWMSMPERR_16
		.global MPWMSMPULR_16
		.global MPWMSMCNTR_16
		.global MPWMSMSCR_16

		# MPIOS Pulse width modulation submodule 17
		.global MPWMSMPERR_17
		.global MPWMSMPULR_17
		.global MPWMSMCNTR_17
		.global MPWMSMSCR_17

		# MPIOS Pulse width modulation submodule 18
		.global MPWMSMPERR_18
		.global MPWMSMPULR_18
		.global MPWMSMCNTR_18
		.global MPWMSMSCR_18

		# MPIOS Pulse width modulation submodule 19
		.global MPWMSMPERR_19
		.global MPWMSMPULR_19
		.global MPWMSMCNTR_19
		.global MPWMSMSCR_19

		# MIOS Modulus counter submodule 22
		.global MMCSMCNT_22
		.global MMCSMML_22
		.global MMCSMSCRD_22
		.global MMCSMSCR_22

		# MIOS Double action submodule 27
		.global MDASMAR_27
		.global MDASMBR_27
		.global MDASMSCRD_27
		.global MDASMSCR_27

		# MIOS Double action submodule 28
		.global MDASMAR_28
		.global MDASMBR_28
		.global MDASMSCRD_28
		.global MDASMSCR_28

		# MIOS Double action submodule 29
		.global MDASMAR_29
		.global MDASMBR_29
		.global MDASMSCRD_29
		.global MDASMSCR_29

		# MIOS Double action submodule 30
		.global MDASMAR_30
		.global MDASMBR_30
		.global MDASMSCRD_30
		.global MDASMSCR_30

		# MIOS Double action submodule 31
		.global MDASMAR_31
		.global MDASMBR_31
		.global MDASMSCRD_31
		.global MDASMSCR_31

		# MIOS Paralell port I/O submodule
		.global MPIOSMDR
		.global MPIOSMDDR

		# MIOS Bus interface Submodule
		.global MIOS1TPCR
		.global MIOS1VNR
		.global MIOS1MCR

		# MIOS Counter / Prescaler submodule
		.global MCPSMSCR
	 
		# MIOS Interrupt request submodule 0
		.global MIOS1SR0
		.global MIOS1ER0
		.global MIOS1RPR0
		.global MIOS1LVL0

		# Mios Interrupt request submodule 1
		.global MIOS1SR1
		.global MIOS1ER1
		.global MIOS1RPR1
		.global MIOS1LVL1

		#-------------------------------------
		# TouCAN (CAN 2.0B Controller)
		#-------------------------------------
		# TouCAN_A
		.global TCNMCR_A
		.global TTR_A
		.global CANICR_A
		.global CANCTRL0_A_CANCTRL1_A
		.global PRESDIV_A_CTRL2_A
		.global TIMER_A
		.global RXGMASKHI_A
		.global RXGMASKLO_A
		.global RX14MASKHI_A
		.global RX14MASKLO_A
		.global RX15MASKHI_A
		.global RX15MASKLO_A
		.global ESTAT_A
		.global IMASK_A
		.global IFLAG_A
		.global RXECTR_A_TXECTR_A

		# TouCAN_B
		.global TCNMCR_B
		.global TTR_B
		.global CANICR_B
		.global CANCTRL0_B_CANCTRL1_B
		.global PRESDIV_B_CTRL2_B
		.global TIMER_B
		.global RXGMASKHI_B
		.global RXGMASKLO_B
		.global RX14MASKHI_B
		.global RX14MASKLO_B
		.global RX15MASKHI_B
		.global RX15MASKLO_B
		.global ESTAT_B
		.global IMASK_B
		.global IFLAG_B
		.global RXECTR_A_TXECTR_B

		#-------------------------------------
		# UIMB (U-Bus to IMB3 Bus Interface)
		#-------------------------------------
		.global UMCR
		.global UTSTCREG
		.global UIPEND

		#-------------------------------------
		# SRAM (Static RAM Access memory)
		#-------------------------------------
		.global SRAMMCR_A
		.global SRAMTST_A
		.global SRAMMCR_B
		.global SRAMTST_B

		#-------------------------------------
		# USIU (Unified System Interface Unit)
		#-------------------------------------
			# General register definitions
			.org 0x0000
SIUMCR:			.word 0
			.org 0x0004
SYPCR:			.word 0
			.org 0x000e
SWSR:			.short 0
			.org 0x0010
SIPEND:			.word 0
			.org 0x0014
SIMASK:			.word 0
			.org 0x0018
SIEL:			.word 0
			.org 0x001c
SIVEC:			.word 0
			.org 0x0020
TESR:			.word 0
			.org 0x0024
SGPIODT1:		.word 0
			.org 0x0028
SGPIODT2:		.word 0
			.org 0x002c
SGPIOCR:		.word 0
			.org 0x0030
EMCR:			.word 0
			.org 0x003c
PDMCR:			.word 0

			# Memory controller registers
			.org 0x0100
BR0:			.word 0
			.org 0x0104
OR0:			.word 0
			.org 0x0108
BR1:			.word 0
			.org 0x010c
OR1:			.word 0
			.org 0x0110
BR2:			.word 0
			.org 0x0114
OR2:			.word 0
			.org 0x0118
BR3:			.word 0
			.org 0x011c
OR3:			.word 0
			.org 0x0140
DMBR:			.word 0
			.org 0x0144
DMOR:			.word 0
			.org 0x0178
MSTAT:			.short 0

			# System integration timers
			.org 0x0200
TBSCR:			.short 0
			.org 0x0204
TBREF0:			.word 0
			.org 0x0208
TBREF1:			.word 0
			.org 0x0220
RTCSC:			.short 0
			.org 0x0224
RTC:			.word 0
			.org 0x0228
RTSEC:			.word 0
			.org 0x022c
RTCAL:			.word 0
			.org 0x0240
PISCR:			.short 0
			.org 0x0244
PITC:			.word 0
			.org 0x0248
PITR:			.word 0

			# Clocks and resets
			.org 0x0280
SCCR:			.word 0
			.org 0x0284
PLPRCR:			.word 0
			.org 0x0288
RSR:			.short 0
			.org 0x028c
COLIR:			.short 0
			.org 0x0290
VSRMCR:			.short 0

			# System IntegrationTimer Keys
			.org 0x0300
TBSCRK:			.word 0
			.org 0x0304
TBREF0K:		.word 0
			.org 0x0308
TBREF1K:		.word 0
			.org 0x030c
TBK:			.word 0
			.org 0x0320
RTCSCK:			.word 0
			.org 0x0324
RTCK:			.word 0
			.org 0x0328
RTSECK:			.word 0
			.org 0x032c
RTCALK:			.word 0
			.org 0x0340
PISCRK:			.word 0
			.org 0x344
PITCK:			.word 0

			# Clocks and reset keys
			.org 0x0380
SCCRK:			.word 0
			.org 0x0384
PLPRCRK:		.word 0
			.org 0x0388
RSRK:			.word 0

		#-------------------------------------
		# CMF (CDR Mone T FLASH EEPROM)
		#-------------------------------------
			# CMF_A
			.org 0x0800
CMFMCR_A:		.word 0
			.org 0x0804
CMFTST_A:		.word 0
			.org 0x0808
CMFCTL_A:		.word 0
	
			# CMF_B
			.org 0x0840
CMFMCR_B:		.word 0
			.org 0x0844
CMFTST_B:		.word 0
			.org 0x0848
CMFCTL_B:		.word 0

		#-------------------------------------
		# DPTRAM (Dual-Port TPU RAM)
		#-------------------------------------
			.org 0x4000
DPTMCR:			.short 0
			.org 0x4002
RAMTST:			.short 0
			.org 0x4004
RAMBAR:			.short 0
			.org 0x4006
MISRH:			.short 0
			.org 0x4008
MISRL:			.short 0
			.org 0x400a
MISCNT:			.short 0

		#-------------------------------------
		# TPU3 (Time processing unit)
		#-------------------------------------
			# TPU-A
			.org 0x8000
TPUMCR_A:		.short 0
			.org 0x8002
TCR_A:			.short 0
			.org 0x8004
DSCR_A:			.short 0
			.org 0x8006
DSSR_A:			.short 0
			.org 0x8008
TICR_A:			.short 0
			.org 0x800a
CIER_A:			.short 0
			.org 0x800c
CFSR0_A:		.short 0
			.org 0x800e
CFSR1_A:		.short 0
			.org 0x8010
CFSR2_A:		.short 0
			.org 0x8012
CFSR3_A:		.short 0
			.org 0x8014
HSQR0_A:		.short 0
			.org 0x8016
HSQR1_A:		.short 0
			.org 0x8018
HSRR0_A:		.short 0
			.org 0x801a
HSRR1_A:		.short 0
			.org 0x801c
CPR0_A:			.short 0
			.org 0x801e
CPR1_A:			.short 0
			.org 0x8020
CISR_A:			.short 0
			.org 0x8022
LR_A:			.short 0
			.org 0x8024
SGLR_A:			.short 0
			.org 0x8026
DCNR_A:			.short 0
			.org 0x8028
TPUMCR2_A:		.short 0
			.org 0x802a
TPUMCR3_A:		.short 0
			.org 0x802c
ISDR_A:			.short 0
			.org 0x802e
ISCR_A:			.short 0

              		# TPU-B
               		.org 0x8400
TPUMCR_B:      		.short 0
               		.org 0x8402
TCR_B:        		.short 0
              		.org 0x8404
DSCR_B:      		.short 0
              		.org 0x8406
DSSR_B:  		.short 0
                	.org 0x8408
TICR_B:         	.short 0
                	.org 0x840a
CIER_B:         	.short 0
                	.org 0x840c
CFSR0_B:        	.short 0
                	.org 0x840e
CFSR1_B:        	.short 0
                	.org 0x8410
CFSR2_B:        	.short 0
                	.org 0x8412
CFSR3_B:        	.short 0
                	.org 0x8414
HSQR0_B:        	.short 0
                	.org 0x8416
HSQR1_B:        	.short 0
                	.org 0x8418
HSRR0_B:        	.short 0
                	.org 0x841a
HSRR1_B:        	.short 0
                	.org 0x841c
CPR0_B:         	.short 0
                	.org 0x841e
CPR1_B:         	.short 0
                	.org 0x8420
CISR_B:         	.short 0
                	.org 0x8422
LR_B:           	.short 0
                	.org 0x8424
SGLR_B:         	.short 0
                	.org 0x8426
DCNR_B:         	.short 0
                	.org 0x8428
TPUMCR2_B:      	.short 0
                	.org 0x842a
TPUMCR3_B:      	.short 0
                	.org 0x842c
ISDR_B:         	.short 0
                	.org 0x842e
ISCR_B:         	.short 0


		#--------------------------------------------
		# QADC64 (Queued Analog-to-digital Converter)
		#--------------------------------------------
			# QUADC-A
			.org 0x8800
QUADC64MCR_A:		.short 0
			.org 0x8802
QUADC64TEST_A:		.short 0
			.org 0x8804
QUADC64INT_A:		.short 0
			.org 0x8806
PORTQA_A_PORTQB_A:	.short 0
			.org 0x8808
DDRQA_A_DDRQB_A:	.short 0
			.org 0x880a
QUACR0_A:		.short 0
			.org 0x880c
QUACR1_A:		.short 0
			.org 0x880e
QUACR2_A:		.short 0
			.org 0x8810
QUASR0_A:		.short 0
			.org 0x8812
QUASR1_A:		.short 0
			.org 0x8a00
CCW_A:			.short 0
			.org 0x8a80
RJURR_A:		.short 0
			.org 0x8b00
LJSRR_A:		.short 0
			.org 0x8b80
LJURR_A:		.short 0

			# QUADC-B
			.org 0x8c00
QUADC64MCR_B:		.short 0
			.org 0x8c02
QUADC64TEST_B:		.short 0
			.org 0x8c04
QUADC64INT_B:		.short 0
			.org 0x8c06
PORTQA_B_PORTQB_B:	.short 0
			.org 0x8c08
DDRQA_B_DDRQB_B:	.short 0
			.org 0x8c0a
QUACR0_B:		.short 0
			.org 0x8c0c
QUACR1_B:		.short 0
			.org 0x8c0e
QUACR2_B:		.short 0
			.org 0x8c10
QUASR0_B:		.short 0
			.org 0x8c12
QUASR1_B:		.short 0
			.org 0x8e00
CCW_B:			.short 0
			.org 0x8e80
RJURR_B:		.short 0
			.org 0x8f00
LJSRR_B:		.short 0
			.org 0x8f80
LJURR_B:		.short 0

		#-------------------------------------------
		# QSMCM (Queued Serial Multi-Channel Module)
		#-------------------------------------------
			.org 0x9000
QSMCMMCR:		.short 0
			.org 0x9002
QTEST:			.short 0
			.org 0x9004
QDSCI_IL:		.short 0
			.org 0x9006
QSPI_IL:		.short 0
			.org 0x9008
SCC1R0:			.short 0
			.org 0x900a
SCC1R1:			.short 0
			.org 0x900c
SC1SR:			.short 0
			.org 0x900e
SC1DR:			.short 0
			.org 0x9014
PORTQS:			.short 0
			.org 0x9016
PQSPAR_DDRQST:		.short 0
			.org 0x9018
SPCR0:			.short 0
			.org 0x901a
SPCR1:			.short 0
			.org 0x901c
SPCR2:			.short 0
			.org 0x901e
SPCR3:			.byte 0
			.org 0x901f
SPSR:			.byte 0
			.org 0x9020
SCC2R0:			.short 0
			.org 0x9022
SCC2R1:			.short 0
			.org 0x9024
SC2SR:			.short 0
			.org 0x9026
SC2DR:			.short 0
			.org 0x9028
QSCI1CR:		.short 0
			.org 0x902a
QSCI1SR:		.short 0
			.org 0x902c
SCTQ:			.short 0
			.org 0x904c
SCRQ:			.short 0
			.org 0x9140
RECRAM:			.short 0
			.org 0x9180
TRAN_RAM:		.short 0
			.org 0x91c0
COMD_RAM:		.short 0

		#---------------------------------------
		# MIOS1 (Modular Input/Output Subsystem)
		#---------------------------------------
			# MPIOS Pulse width modulation submodule 0
			.org 0xa000
MPWMSMPERR_0:		.short 0
			.org 0xa002
MPWMSMPULR_0:		.short 0
			.org 0xa004
MPWMSMCNTR_0:		.short 0
			.org 0xa006
MPWMSMSCR_0:		.short 0
		
			# MPIOS Pulse width modulation submodule 1
			.org 0xa008
MPWMSMPERR_1:		.short 0
			.org 0xa00a
MPWMSMPULR_1:		.short 0
			.org 0xa00c
MPWMSMCNTR_1:		.short 0
			.org 0xa00e
MPWMSMSCR_1:		.short 0

			# MPIOS Pulse width modulation submodule 2
			.org 0xa010
MPWMSMPERR_2:		.short 0
			.org 0xa012
MPWMSMPULR_2:		.short 0
			.org 0xa014
MPWMSMCNTR_2:		.short 0
			.org 0xa016
MPWMSMSCR_2:		.short 0

			# MPIOS Pulse width modulation submodule 3
			.org 0xa018
MPWMSMPERR_3:		.short 0
			.org 0xa01a
MPWMSMPULR_3:		.short 0
			.org 0xa01c
MPWMSMCNTR_3:		.short 0
			.org 0xa01e
MPWMSMSCR_3:		.short 0

			# MIOS Modulus counter submodule 6
			.org 0xa030
MMCSMCNT_6:		.short 0
			.org 0xa032
MMCSMML_6:		.short 0
			.org 0xa034
MMCSMSCRD_6:		.short 0
			.org 0xa036
MMCSMSCR_6:		.short 0

			# MIOS Double Action submodule 11
			.org 0xa058
MDASMAR_11:		.short 0
			.org 0xa05a
MDASMBR_11:		.short 0
			.org 0xa05c
MDASMSCRD_11:		.short 0
			.org 0xa05e
MDASMSCR_11:		.short 0

			# MIOS Double Action submodule 12
			.org 0xa060
MDASMAR_12:		.short 0
			.org 0xa062
MDASMBR_12:		.short 0
			.org 0xa064
MDASMSCRD_12:		.short 0
			.org 0xa066
MDASMSCR_12:		.short 0

			# MIOS Double Action submodule 13
			.org 0xa068
MDASMAR_13:		.short 0
			.org 0xa06a
MDASMBR_13:		.short 0
			.org 0xa06c
MDASMSCRD_13:		.short 0
			.org 0xa06e
MDASMSCR_13:		.short 0

			# MIOS Double Action submodule 14
			.org 0xa070
MDASMAR_14:		.short 0
			.org 0xa072
MDASMBR_14:		.short 0
			.org 0xa074
MDASMSCRD_14:		.short 0
			.org 0xa076
MDASMSCR_14:		.short 0

			# MIOS Double Action submodule 15
			.org 0xa078
MDASMAR_15:		.short 0
			.org 0xa07a
MDASMBR_15:		.short 0
			.org 0xa07c
MDASMSCRD_15:		.short 0
			.org 0xa07e
MDASMSCR_15:		.short 0

			# MPIOS Pulse width modulation submodule 16
			.org 0xa080
MPWMSMPERR_16:		.short 0
			.org 0xa082
MPWMSMPULR_16:		.short 0
			.org 0xa084
MPWMSMCNTR_16:		.short 0
			.org 0xa086
MPWMSMSCR_16:		.short 0

			# MPIOS Pulse width modulation submodule 17
			.org 0xa088
MPWMSMPERR_17:		.short 0
			.org 0xa08a
MPWMSMPULR_17:		.short 0
			.org 0xa08c
MPWMSMCNTR_17:		.short 0
			.org 0xa08e
MPWMSMSCR_17:		.short 0

			# MPIOS Pulse width modulation submodule 18
			.org 0xa090
MPWMSMPERR_18:		.short 0
			.org 0xa092
MPWMSMPULR_18:		.short 0
			.org 0xa094
MPWMSMCNTR_18:		.short 0
			.org 0xa096
MPWMSMSCR_18:		.short 0

			# MPIOS Pulse width modulation submodule 19
			.org 0xa098
MPWMSMPERR_19:		.short 0
			.org 0xa09a
MPWMSMPULR_19:		.short 0
			.org 0xa09c
MPWMSMCNTR_19:		.short 0
			.org 0xa09e
MPWMSMSCR_19:		.short 0

			# MIOS Modulus counter submodule 22
			.org 0xa0b0
MMCSMCNT_22:		.short 0
			.org 0xa0b2
MMCSMML_22:		.short 0
			.org 0xa0b4
MMCSMSCRD_22:		.short 0
			.org 0xa0b6
MMCSMSCR_22:		.short 0

			# MIOS Double action submodule 27
			.org 0xa0d8
MDASMAR_27:		.short 0
			.org 0xa0da
MDASMBR_27:		.short 0
			.org 0xa0dc
MDASMSCRD_27:		.short 0
			.org 0xa0de
MDASMSCR_27:		.short 0
			# MIOS Double action submodule 28
			.org 0xa0e0
MDASMAR_28:		.short 0
			.org 0xa0e2
MDASMBR_28:		.short 0
			.org 0xa0e4
MDASMSCRD_28:		.short 0
			.org 0xa0e6
MDASMSCR_28:		.short 0
			# MIOS Double action submodule 29
			.org 0xa0e8
MDASMAR_29:		.short 0
			.org 0xa0ea
MDASMBR_29:		.short 0
			.org 0xa0ec
MDASMSCRD_29:		.short 0
			.org 0xa0ee
MDASMSCR_29:		.short 0
			# MIOS Double action submodule 30
			.org 0xa0f0
MDASMAR_30:		.short 0
			.org 0xa0f2
MDASMBR_30:		.short 0
			.org 0xa0f4
MDASMSCRD_30:		.short 0
			.org 0xa0f6
MDASMSCR_30:		.short 0
			# MIOS Double action submodule 31
			.org 0xa0f8
MDASMAR_31:		.short 0
			.org 0xa0fa
MDASMBR_31:		.short 0
			.org 0xa0fc
MDASMSCRD_31:		.short 0
			.org 0xa0fe
MDASMSCR_31:		.short 0

			# MIOS Paralell port I/O submodule
			.org 0xa100
MPIOSMDR:		.short 0
			.org 0xa102
MPIOSMDDR:		.short 0

			# MIOS Bus interface Submodule
			.org 0xa800
MIOS1TPCR:		.short 0
			.org 0xa802
MIOS1VNR:		.short 0
			.org 0xa806
MIOS1MCR:		.short 0

			# MIOS Counter / Prescaler submodule
			.org 0xa816
MCPSMSCR:		.short 0

			# MIOS Interrupt request submodule 0
			.org 0xac00
MIOS1SR0:		.short 0
			.org 0xac04
MIOS1ER0:		.short 0
			.org 0xac06
MIOS1RPR0:		.short 0
			.org 0xac30
MIOS1LVL0:		.short 0

			# Mios Interrupt request submodule 1
			.org 0xac40
MIOS1SR1:		.short 0
			.org 0xac44
MIOS1ER1:		.short 0
			.org 0xac46
MIOS1RPR1:		.short 0
			.org 0xac70
MIOS1LVL1:		.short 0

		#-------------------------------------
		# TouCAN (CAN 2.0B Controller)
		#-------------------------------------
			# TouCAN_A
			.org 0xb080
TCNMCR_A:		.short 0
			.org 0xb082
TTR_A:			.short 0
			.org 0xb084
CANICR_A:		.short 0
			.org 0xb086
CANCTRL0_A_CANCTRL1_A:	.short 0
			.org 0xb088
PRESDIV_A_CTRL2_A:	.short 0
			.org 0xb08a
TIMER_A:		.short 0
			.org 0xb090
RXGMASKHI_A:		.short 0
			.org 0xb092
RXGMASKLO_A:		.short 0
			.org 0xb094
RX14MASKHI_A:		.short 0
			.org 0xb096
RX14MASKLO_A:		.short 0
			.org 0xb098
RX15MASKHI_A:		.short 0
			.org 0xb09a
RX15MASKLO_A:		.short 0
			.org 0xb0a0
ESTAT_A:		.short 0
			.org 0xb0a2
IMASK_A:		.short 0
			.org 0xb0a4
IFLAG_A:		.short 0
			.org 0xb0a6
RXECTR_A_TXECTR_A:	.short 0

			# TouCAN_B
			.org 0xb480
TCNMCR_B:		.short 0
			.org 0xb482
TTR_B:			.short 0
			.org 0xb484
CANICR_B:		.short 0
			.org 0xb486
CANCTRL0_B_CANCTRL1_B:	.short 0
			.org 0xb488
PRESDIV_B_CTRL2_B:	.short 0
			.org 0xb48a
TIMER_B:		.short 0
			.org 0xb490
RXGMASKHI_B:		.short 0
			.org 0xb492
RXGMASKLO_B:		.short 0
			.org 0xb494
RX14MASKHI_B:		.short 0
			.org 0xb496
RX14MASKLO_B:		.short 0
			.org 0xb498
RX15MASKHI_B:		.short 0
			.org 0xb49a
RX15MASKLO_B:		.short 0
			.org 0xb4a0
ESTAT_B:		.short 0
			.org 0xb4a2
IMASK_B:		.short 0
			.org 0xb4a4
IFLAG_B:		.short 0
			.org 0xb4a6
RXECTR_A_TXECTR_B:	.short 0

		#-------------------------------------
		# UIMB (U-Bus to IMB3 Bus Interface)
		#-------------------------------------
			.org 0xbf80
UMCR:			.word 0
			.org 0xbf90
UTSTCREG:		.word 0
			.org 0xbfa0
UIPEND:			.word 0

		#-------------------------------------
		# SRAM (Static RAM Access memory)
		#-------------------------------------
			.org 0x84000
SRAMMCR_A:		.short 0
			.org 0x84004
SRAMTST_A:		.short 0
			.org 0x84008
SRAMMCR_B:		.short 0
			.org 0x8400c
SRAMTST_B:		.short 0
