#ifndef CANMESSAGEDISPATCHER_H
#define CANMESSAGEDISPATCHER_H

//----------------------------------
// Includes and forward declarations
//----------------------------------
class CommunicationObject;
#include "cyg/io/caltypes.h"
#include "pkgconf/io_cal.h"
#include <cyg/kal/kthread.h>

//------------------
// Class declaration
//------------------
class CanMessageDispatcher : public KThread
{
  public:
                            CanMessageDispatcher(char * a_name);
    virtual                 ~CanMessageDispatcher();

    void                    attach(CommunicationObject * a_cob);
    void                    detach(CommunicationObject * a_cob);

    void                    start(can_io_handle_t a_handle);
    void                    stop(void);

  protected:
    // Overloaded virtuals from base class KThread
    virtual void            threadEntry(void);

  private:
    can_io_handle_t         m_io_handle;
    unsigned char           m_stack[CYGNUM_CAL_THREAD_STACK_SIZE];
    CommunicationObject *   m_cob[256][8];
};

#endif // CANMESSAGEDISPATCHER
