#ifndef KTHREAD_CXX
#define KTHREAD_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/kal/kthread.h"

//---------------------
// Class implementation
//---------------------
// Constructor
KThread::KThread(unsigned int a_priority, char * a_name,
                 void * a_stack, size_t a_stacksize)
{
  cyg_thread_create(a_priority, 
                    (cyg_thread_entry_t *)sthreadEntry, 
                    (cyg_addrword_t)this, 
                    a_name, a_stack, 
                    a_stacksize, 
                    &m_handle, 
                    this);
}

// Provide an (empty) virtual destructor
KThread::~KThread()
{
  cyg_thread_kill(m_handle);
}

// suspend
void KThread::suspend(void)
{
  cyg_thread_suspend(m_handle);
}

// resume
void KThread::resume(void)
{
  cyg_thread_resume(m_handle);
}

// release
void KThread::release(void)
{
  cyg_thread_release(m_handle);
}

// sthreadEntry
void KThread::sthreadEntry(KThread * a_thread)
{
  a_thread->threadEntry();
}

#endif // KTHREAD_CXX
