#ifndef CALTST_CXX
#define CALTST_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <stdio.h>
#include <cyg/io/cmsvar.h>
#include <cyg/kal/kdelay.h>
#include <cyg/kal/kdefs.h>
#include <cyg/kal/ktimer.h>

//----------------------
// Some type definitions
//----------------------
typedef ROBasicClientVar<DWORD> TROBasicClient;
typedef ROBasicServerVar<DWORD> TROBasicServer;

typedef WOBasicClientVar<DWORD> TWOBasicClient;
typedef WOBasicServerVar<DWORD> TWOBasicServer;

typedef RWBasicClientVar<DWORD> TRWBasicClient;
typedef RWBasicServerVar<DWORD> TRWBasicServer;

typedef ROMuxClientVar<DWORD> TROMuxClient;
typedef ROMuxServerVar<DWORD> TROMuxServer;

typedef WOMuxClientVar<DWORD> TWOMuxClient;
typedef WOMuxServerVar<DWORD> TWOMuxServer;

typedef RWMuxClientVar<DWORD> TRWMuxClient;
typedef RWMuxServerVar<DWORD> TRWMuxServer;

class TestWOServerVar : public TWOBasicServer
{
  public:
                 TestWOServerVar(unsigned int a_inhibit, 
                                 unsigned char a_priority, 
                                 const char * a_name,
                                 CAN_msgid a_id, 
                                 can_io_handle_t a_handle)
                      : TWOBasicServer(a_inhibit, a_priority, a_name, a_id, a_handle) 
                 {
                 }
    virtual      ~TestWOServerVar() 
                 {
                 }

  protected:
    virtual void dataIndication(DWORD a_data)
                 {
                 printf("WO server received %d\n", a_data);
                 }
};

class TestRWServerVar : public TRWBasicServer
{
  public:
                 TestRWServerVar(unsigned int a_inhibit, 
                                 unsigned char a_priority, 
                                 const char * a_name,
                                 CAN_msgid a_txid, CAN_msgid a_rxid, 
                                 can_io_handle_t a_handle)
                      : TRWBasicServer(a_inhibit, a_priority, a_name, a_txid, a_rxid, a_handle)
                 {
                   m_data = 0; 
                 }
    virtual      ~TestRWServerVar() 
                 {
                 }

  protected:
    DWORD        m_data;

    virtual bool dataIndication(DWORD a_data, unsigned char * a_response)
                 {
                 printf("RW server received %d\n", a_data); 
                 m_data = a_data;
                 return true;

//                 printf("RW server received %d\n", a_data);
//                 m_data = a_data;
//                 a_response[0] = 0x30;
//                 a_response[1] = 0x31;
//                 a_response[2] = 0x32;
//                 a_response[3] = 0x33;
//                 return false;
                 }
    virtual bool dataRequest(DWORD * a_data, unsigned char * a_response)
                 {
                 *a_data = m_data;
                 return true;

//                 a_response[0] = 0x33;
//                 a_response[1] = 0x32;
//                 a_response[2] = 0x31;
//                 a_response[3] = 0x30;
//                 return false;
                 }
};

class TestROMuxServer : public TROMuxServer
{
  public:
                 TestROMuxServer(unsigned int a_inhibit,
                                 unsigned char a_priority,
                                 const char * a_name,
                                 CAN_msgid a_txid, CAN_msgid a_rxid,
                                 can_io_handle_t a_handle)
                     : TROMuxServer(a_inhibit, a_priority, a_name, a_txid, a_rxid, a_handle)
                 {
                 }
    virtual      ~TestROMuxServer() {}

  protected:
    virtual bool dataRequest(DWORD * a_data, unsigned char a_mux, unsigned char * a_response)
                 {
//                 *a_data = 2*a_mux;
//                 return true;

                 a_response[0] = 0x33;
                 a_response[1] = 0x32;
                 a_response[2] = 0x31;
                 a_response[3] = 0x30;
                 return false;
                 }
};

class TestWOMuxServer : public TWOMuxServer
{
  public:
                 TestWOMuxServer(unsigned int a_inhibit,
                                 unsigned char a_priority,
                                 const char * a_name,
                                 CAN_msgid a_cobid,
                                 can_io_handle_t a_handle)
                     : TWOMuxServer(a_inhibit, a_priority, a_name, a_cobid, a_handle)
                 {
                 }
  protected:
    virtual void dataIndication(DWORD a_data, unsigned char a_mux)
                 {
                 printf("WO muxserver received %d\n", a_data);
                 printf("WO muxserver for %d\n", a_mux);
                 }
};

class TestRWMuxServer : public TRWMuxServer
{
  public:
                 TestRWMuxServer(unsigned int a_inhibit,
                                 unsigned char a_priority,
                                 const char * a_name,
                                 CAN_msgid a_txcob, CAN_msgid a_rxcob,
                                 can_io_handle_t a_handle)
                     : TRWMuxServer(a_inhibit, a_priority, a_name, a_txcob, a_rxcob, a_handle)
                 {
                 }
  protected:
    virtual bool dataIndication(DWORD a_data, unsigned char a_mux, unsigned char * a_response)
                 {
//                 printf("RW muxserver received %d\n", a_data);
//                 printf("RW muxserver for %d", a_mux);
//                 return true;

                 a_response[0] = 0x36;
                 a_response[1] = 0x37;
                 a_response[2] = 0x38;
                 a_response[3] = 0x39;
                 return false;
                 }
    virtual bool dataRequest(DWORD * a_data, unsigned char a_mux, unsigned char * a_response)
                 {
//                 *a_data = 2*a_mux;
//                 return true;

                 a_response[0] = 0x39;
                 a_response[1] = 0x38;
                 a_response[2] = 0x37;
                 a_response[3] = 0x36;
                 return false;
                 }
};

class TestClass : public KTimerClient
{
  public:
    virtual void timeOut(KTimer * a_timer)
                 {
                 printf("It is TimeOut, hoera, hoera, hoera\n");
                 }
};

//-----------------
// The main program
//-----------------
int main(void)
{
//  KTimer::enableTiming();

  printf("Starting test\n");
  printf("=============\n");

  // Start a 5 seconds high resolution timer
  TestClass tester;
  KTimer timer1(&tester, KTimer::High, KTimer::Background);
  KTimer timer2(&tester, KTimer::High, KTimer::Background);
  KTimer timer3(&tester, KTimer::High, KTimer::Background);
  KTimer timer4(&tester, KTimer::High, KTimer::Background);
  KTimer timer5(&tester, KTimer::High, KTimer::Background);
  KTimer timer6(&tester, KTimer::Low, KTimer::Background);
  KTimer timer7(&tester, KTimer::Normal, KTimer::Background);
  timer1.start(1000000);
  timer2.start(2000000);
  timer3.start(3000000);
  timer4.start(4000000);
  timer5.start(5000000);
  timer6.start(1000000);
  timer7.start(1000000);

  // Configure the canbus for 500 KBit/s 
  can_io_handle_t caldev1;
  can_io_handle_t caldev2;
  Cyg_ErrNo error;

  error = can_io_lookup("/dev/cal1", &caldev1);
  error = can_io_lookup("/dev/cal2", &caldev2);

  can_info_t info;
  DWORD len;

  info.m_baud    = CAN_BAUD_KBIT_500;
  info.m_tx_mode = CAN_TX_MODE_DEFAULT;
  info.m_rx_mode = CAN_RX_MODE_DEFAULT;
  len = sizeof(info);

  can_io_set_config(caldev1, CAN_IO_SET_CONFIG_CAN_INFO, &info, &len);
  can_io_set_config(caldev2, CAN_IO_SET_CONFIG_CAN_INFO, &info, &len);

  // Now create the CMS objects
  TROBasicClient robasicclient(100, 5, "robasicclient", 1, caldev1);
  TROBasicServer robasicserver(0, 5, "robasicserver", 1, caldev2);
  robasicclient.define();
  robasicserver.define();

  TWOBasicClient wobasicclient(0, 5, "wobasicclient", 2, caldev1);
  TestWOServerVar wobasicserver(0, 5, "wobasicserver", 2, caldev2);
  wobasicclient.define();
  wobasicserver.define();

  TRWBasicClient rwbasicclient(0, 5, "rwbasicclient", 3, 4, caldev1);
  TestRWServerVar rwbasicserver(0, 5, "rwbasicclient", 4, 3, caldev2);
  rwbasicclient.define();
  rwbasicserver.define();

  TROMuxClient romuxclient(0, 5, "romuxclient", 5, 6, caldev1);
  TestROMuxServer romuxserver(0, 5, "romuxserver", 6, 5, caldev2);
  romuxclient.define();
  romuxserver.define();

  TWOMuxClient womuxclient(0, 5, "womuxclient", 7, caldev1);
  TestWOMuxServer womuxserver(0, 5, "womuxserver", 7, caldev2);
  womuxclient.define();
  womuxserver.define();

  TRWMuxClient rwmuxclient(0, 5, "rwmuxclient", 8, 9, caldev1);
  TestRWMuxServer rwmuxserver(0, 5, "rwmuxclient", 9, 8, caldev2);
  rwmuxclient.define();
  rwmuxserver.define();

  // Now the test can start

  robasicserver.updateVariable(8);

  DWORD readvar = 0;
  DWORD update  = 0;

  unsigned char response[8];
/*
  robasicclient.readVariable(&readvar, response, 500);
  printf("RO client read %d\n", readvar);
*/  
  wobasicclient.writeVariable(138, response);

  if(rwbasicclient.writeVariable(2356, response) == -CMS_APPLICATIONERR)
    printf("RW client writeresponse %c%c%c%c\n", (char)(response[0]), 
                                                 (char)(response[1]), 
                                                 (char)(response[2]), 
                                                 (char)(response[3]));
  if(rwbasicclient.readVariable(&readvar, response) == -CMS_APPLICATIONERR)
    printf("RW client readresponse %c%c%c%c\n", (char)(response[0]), 
                                                (char)(response[1]), 
                                                (char)(response[2]), 
                                                (char)(response[3]));
  else
    printf("RW client read %d\n", readvar);

  if(rwbasicclient.readVariable(&readvar, response) == -CMS_APPLICATIONERR)
    printf("RW client readresponse %c%c%c%c\n", (char)(response[0]), 
                                                (char)(response[1]), 
                                                (char)(response[2]), 
                                                (char)(response[3]));
  else
    printf("RW client read %d\n", readvar);

  if(romuxclient.readVariable(&readvar, 126, response, 500) == -CMS_APPLICATIONERR)
    printf("RO muxclient readresponse %c%c%c%c\n", (char)(response[0]),
                                                   (char)(response[1]),
                                                   (char)(response[2]),
                                                   (char)(response[3]));
  else
    printf("RO muxclient read %d\n", readvar);

  womuxclient.writeVariable(15961, 15, response);

  if(rwmuxclient.writeVariable(73, 121, response, 500) == -CMS_APPLICATIONERR)
    printf("RW muxclient writeresponse %c%c%c%c\n", (char)(response[0]),
                                                    (char)(response[1]),
                                                    (char)(response[2]),
                                                    (char)(response[3]));
  if(rwmuxclient.readVariable(&readvar, 12, response, 500) == -CMS_APPLICATIONERR)
    printf("RW muxclient readresponse %c%c%c%c\n", (char)(response[0]),
                                                   (char)(response[1]),
                                                   (char)(response[2]),
                                                   (char)(response[3]));
  else
    printf("RW muxclient read %d\n", readvar);

  int errorcount = 0;

  for(;;)
  {
    KDelay(20);

    update++;
    robasicserver.updateVariable(update);
    readvar = 0;
    if(robasicclient.readVariable(&readvar, response, 500) != ENOERR)
    {
      printf("Read Error\n");
      errorcount++;
    }

    if(readvar != update)
    {
      printf("Another read Error\n");
      errorcount++;
    }

    if((update % 10) == 0)
      printf("alive\n");
  }

  return 0;
}

#endif // CALTST_CXX
