#ifndef CANTST_CXX
#define CANTST_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include <cyg/io/canio.h>
#include <cyg/io/can.h>
#include <cyg/io/io.h>
#include <stdio.h>

#include <cyg/io/cmsvariable.h>

//-------------------------
// Some function prototypes
//-------------------------
void print_can_info(can_info_t * info);
void print_can_message(can_message * msg);

void action1(void)
{
  // Something we can set a breakpoint on
}

void action2(void)
{
  // something we can set a breakpoint on
}

//-----------------
// The main program
//-----------------
int main(void)
{
  cyg_io_handle_t candev1;
  cyg_io_handle_t candev2;
  Cyg_ErrNo error;

  error = cyg_io_lookup("/dev/can1", &candev1);
  error = cyg_io_lookup("/dev/can2", &candev2);

  can_info_t info;
  cyg_uint32 len;

  info.m_baud    = CAN_BAUD_KBIT_500;
  info.m_tx_mode = CAN_TX_MODE_DEFAULT;
  info.m_rx_mode = CAN_RX_MODE_DEFAULT;
  len = sizeof(info);

  cyg_io_set_config(candev1, CAN_IO_SET_CONFIG_CAN_INFO, &info, &len);
  cyg_io_set_config(candev2, CAN_IO_SET_CONFIG_CAN_INFO, &info, &len);

  error = cyg_io_get_config(candev1, CAN_IO_GET_CONFIG_CAN_INFO, &info, &len);
  printf("CAN 1\n");
  printf("=====\n");
  if(!error)
    print_can_info(&info);
  else
    printf("error\n");

  error = cyg_io_get_config(candev2, CAN_IO_GET_CONFIG_CAN_INFO, &info, &len);
  printf("CAN 2\n");
  printf("=====\n");
  if(!error)
    print_can_info(&info);
  else
    printf("error\n");
/*
  can_rxid_action_t rxaction;
  len = sizeof(can_rxid_action_t);
  rxaction.m_can_id = 100;
  rxaction.m_action = action1;
  cyg_io_set_config(candev1, CAN_IO_SET_CONFIG_RXID1_INT_ACTION, &rxaction, &len);

  rxaction.m_can_id = 200;
  rxaction.m_action = action2;
  cyg_io_set_config(candev1, CAN_IO_SET_CONFIG_RXID2_INT_ACTION, &rxaction, &len);

  cyg_uint16 cob_id;
  len = sizeof(cyg_uint16);

  cob_id = 1;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);
  cob_id = 2;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);
  cob_id = 3;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);
  cob_id = 4;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);
  cob_id = 5;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);
  cob_id = 6;
  cyg_io_set_config(candev2, CAN_IO_ADD_RX_ID, &cob_id, &len);

  cob_id = 1;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);
  cob_id = 2;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);
  cob_id = 3;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);
  cob_id = 4;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);
  cob_id = 5;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);
  cob_id = 6;
  cyg_io_set_config(candev2, CAN_IO_ADD_RTR_ID, &cob_id, &len);

  can_message msg;
  msg.m_CAN_id = 1;
  msg.m_DLC = 8;
  msg.m_RTR = 0;
  msg.m_Data[0] = 1;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 2;
  msg.m_Data[0] = 2;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 3;
  msg.m_Data[0] = 3;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 4;
  msg.m_Data[0] = 4;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 5;
  msg.m_Data[0] = 5;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 6;
  msg.m_Data[0] = 6;
  msg.m_Data[1] = 2;
  msg.m_Data[2] = 3;
  msg.m_Data[3] = 4;
  msg.m_Data[4] = 5;
  msg.m_Data[5] = 6;
  msg.m_Data[6] = 7;
  msg.m_Data[7] = 8;
  len = sizeof(can_message);
  cyg_io_set_config(candev2, CAN_IO_UPDATE_RTR_BUFFER, &msg, &len);

  msg.m_CAN_id = 0;

  for(;;)
  {
    msg.m_CAN_id++;
    msg.m_RTR = 0;
    len = sizeof(can_message);

    cyg_io_write(candev1, &msg, &len);
    if(cyg_io_read(candev2, &msg, &len) == ENOERR)
      print_can_message(&msg);

    if(msg.m_CAN_id == 3)
    {
      cyg_io_set_config(candev1, CAN_IO_RESET, 0, &len);
      cyg_io_set_config(candev2, CAN_IO_RESET, 0, &len);
    }

    if(msg.m_CAN_id == 6)
      msg.m_CAN_id = 0;
  }  
*/
  CAL_Unsigned32_BasicVar basic_client("#testb_client", 
                                        CAL_Unsigned32_BasicVar::Client, 
                                        CAL_Unsigned32_BasicVar::Read_Write, 
                                        CMS_Object::rx, 
                                        CMS_Object::tx);
  CAL_Unsigned32_BasicVar basic_server("#testb_server", 
                                        CAL_Unsigned32_BasicVar::Server, 
                                        CAL_Unsigned32_BasicVar::Read_Write, 
                                        CMS_Object::rx, 
                                        CMS_Object::tx);

  CAL_Unsigned32_MuxVar mux_client("#testm_client", "#testmux__set", 56, 
                                    CAL_Unsigned32_MuxVar::Client, 
                                    CAL_Unsigned32_MuxVar::Read_Write, 
                                    CMS_Object::rx, 
                                    CMS_Object::tx);
  CAL_Unsigned32_MuxVar mux_server("#testm_server", "#testmux__set", 56, 
                                    CAL_Unsigned32_MuxVar::Server, 
                                    CAL_Unsigned32_MuxVar::Read_Write, 
                                    CMS_Object::rx, 
                                    CMS_Object::tx);

  return 0;
}

// print_can_info
void print_can_info(can_info_t * info)
{
  printf("running at ");
  switch(info->m_baud)
  {
    case CAN_BAUD_KBIT_1000:
      printf("1 MBit\n");
      break;
    case CAN_BAUD_KBIT_800:
      printf("800 kBit\n");
      break;
    case CAN_BAUD_KBIT_500:
      printf("500 kBit\n");
      break;
    case CAN_BAUD_KBIT_250:
      printf("250 kbit\n");
      break;
    case CAN_BAUD_KBIT_125:
      printf("125 kbit\n");
      break;
    case CAN_BAUD_KBIT_100:
      printf("100 kbit\n");
      break;
    case CAN_BAUD_KBIT_50:
      printf("50 kbit\n");
      break;
    case CAN_BAUD_KBIT_20:
      printf("20 kbit\n");
      break;
    case CAN_BAUD_KBIT_10:
    default:
      printf("10 kbit\n");
      break;
  }
}

// print_can_message
void print_can_message(can_message * msg)
{
  printf("\n\nmessage\n");
  printf(    "=======\n");
  printf("CAN_id  : %d\n",   msg->m_CAN_id);
  printf("RTR     : %d\n",   msg->m_RTR);
  printf("DLC     : %d\n",   msg->m_DLC);
  printf("Data[0] : 0x%x\n", msg->m_Data[0]);
  printf("Data[1] : 0x%x\n", msg->m_Data[1]);
  printf("Data[2] : 0x%x\n", msg->m_Data[2]);
  printf("Data[3] : 0x%x\n", msg->m_Data[3]);
  printf("Data[4] : 0x%x\n", msg->m_Data[4]);
  printf("Data[5] : 0x%x\n", msg->m_Data[5]);
  printf("Data[6] : 0x%x\n", msg->m_Data[6]);
  printf("Data[7] : 0x%x\n", msg->m_Data[7]);
}

#endif // CANTST_CXX
